import { Subscribable } from 'rx-subject';
export interface ComponentFromStreamFactory<C extends Component<N, any, any>, N> {
    <P = {}, Q = P, A = P>(render: (props: Q) => N, operator?: Operator<A, Q>, onprops?: PropsDispatcherFactory<P, A>): ComponentFromStreamConstructor<C, N>;
    <P = {}, A = P, Q = P, S = void>(render: (props: Q) => N, operator: Operator<S, Q>, onprops: PropsDispatcherFactory<P, A>, ...middlewares: Middleware<A>[]): ComponentFromStreamConstructor<C, N>;
}
export interface ComponentFromStreamOptions {
}
export interface ComponentFromStreamConstructor<C extends Component<N, any, any>, N> {
    new <P = {}, Q = P>(props?: P, context?: any): C & ComponentFromStream<N, P, Q>;
}
export interface ComponentFromStream<N, P = {}, Q = P> extends Component<N, P, ViewPropsState<Q>> {
    componentWillMount(): void;
    componentWillReceiveProps(nextProps: Readonly<P>, nextContext: any): void;
    componentWillUnmount(): void;
    shouldComponentUpdate(props: Readonly<P>, state: Readonly<ViewPropsState<Q>>): boolean;
}
export interface ComponentConstructor<N> {
    new <P = {}, S = {}>(props: P, context?: any): Component<N, P, S>;
}
export interface Component<N, P = {}, S = {}> {
    setState(state: Reducer<S, P> | Partial<S>, cb?: () => void): void;
    render(props?: P, state?: S, context?: any): N;
    props: Readonly<P>;
    state: Readonly<S | null>;
    context: any;
}
export interface ViewPropsState<Q> {
    props: Q;
}
export declare type Operator<I, O> = <S extends Subscribable<I>, T extends Subscribable<O>>(source$: S) => T;
export declare type PropsDispatcherFactory<P, A = P> = <S extends Subscribable<A>>(dispatch: (v: A) => void, source$?: S) => (props: P) => void;
export declare type Middleware<I> = (dispatch: (...args: any[]) => void, source$?: Subscribable<I>, fromESObservable?: <T, O extends Subscribable<T>>(stream: Subscribable<T>) => O, toESObservable?: <T, O extends Subscribable<T>>(stream: O) => Subscribable<T>) => (...args: any[]) => void;
export declare type Reducer<A, V> = (acc: A, val: V) => A;
export { Subscribable };
export default function createComponentFromStreamFactory<C extends Component<N, any, any>, N>(ComponentCtor: new (props: any, context?: any) => C & Component<N, any, any>, fromESObservable: <T, O extends Subscribable<T>>(stream: Subscribable<T>) => O, opts?: Partial<ComponentFromStreamOptions>): ComponentFromStreamFactory<C, N>;
export default function createComponentFromStreamFactory<C extends Component<N, any, any>, N>(ComponentCtor: new (props: any, context?: any) => C & Component<N, any, any>, fromESObservable: <T, O extends Subscribable<T>>(stream: Subscribable<T>) => O, toESObservable: <T, O extends Subscribable<T>>(stream: O) => Subscribable<T>, opts?: Partial<ComponentFromStreamOptions>): ComponentFromStreamFactory<C, N>;
