"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
;
const rx_subject_1 = require("rx-subject");
function createComponentFromStreamFactory(ComponentCtor, fromES, toESOrOpts = identity, opts = {}) {
    if (!isFunction(toESOrOpts)) {
        return createComponentFromStreamFactory(ComponentCtor, fromES, void 0, toESOrOpts);
    }
    const toES = toESOrOpts;
    return function createComponentFromStream(render, operator = identity, onProps = identity, ...middlewares) {
        return class ComponentFromStreamBaseClass extends ComponentCtor {
            constructor() {
                super(...arguments);
                this.state = {};
                this._setProps = (props) => this.setState({ props });
                this._applyMiddleware = (next, middleware) => middleware(next, this._q.source$, fromES, toES);
                this._unsubscribe = () => this._sub.unsubscribe();
            }
            render() {
                return !this.state.props ? null : render(this.state.props);
            }
            componentWillMount() {
                this._q = rx_subject_1.default();
                const q$ = fromES(this._q.source$);
                this._sub =
                    toES(operator(q$)).subscribe(this._setProps);
                this._q.source$.subscribe(nop, this._unsubscribe, this._unsubscribe);
                const next = middlewares.reduceRight(this._applyMiddleware, this._q.sink.next);
                this._onProps = onProps(next, q$);
                this._onProps(this.props);
            }
            componentWillReceiveProps(props) {
                this._onProps(props);
            }
            componentWillUnmount() {
                this._q.sink.complete();
            }
            shouldComponentUpdate(_, state) {
                return state.props !== this.state.props;
            }
        };
    };
}
exports.default = createComponentFromStreamFactory;
function isFunction(v) {
    return typeof v === 'function';
}
function identity(val) {
    return val;
}
function nop() { }
